# https://help.github.com/en/categories/automating-your-workflow-with-github-actions

on:
  - "pull_request"
  - "push"

name: "CI"

jobs:
  coding-guidelines:
    name: "Coding Guidelines"

    runs-on: "ubuntu-latest"

    steps:
      - name: "Checkout"
        uses: "actions/checkout@v2"

      - name: "Run friendsofphp/php-cs-fixer"
        run: "php7.3 ./tools/php-cs-fixer fix --diff-format=udiff --dry-run --show-progress=dots --using-cache=no --verbose"

  type-checker:
    name: "Type Checker"

    runs-on: "ubuntu-latest"

    steps:
      - name: "Checkout"
        uses: "actions/checkout@v2"

      - name: "Set COMPOSER_ROOT_VERSION environment variable"
        uses: "docker://ergebnis/composer-root-version-action:0.1.3"

      - name: "Update dependencies with composer"
        run: "php7.3 ./tools/composer update --no-ansi --no-interaction --no-progress"

      - name: "Run vimeo/psalm"
        run: "php7.3 ./tools/psalm --config=.psalm/config.xml --no-progress --shepherd --show-info=false --stats"

  backward-compatibility:
    name: Backward Compatibility

    runs-on: ubuntu-latest

    steps:
      - name: Checkout
        uses: actions/checkout@v2
        with:
          fetch-depth: 0

      - name: Fetch tags
        run: git fetch --depth=1 origin +refs/tags/*:refs/tags/*

      - name: Install PHP with extensions
        uses: shivammathur/setup-php@v2
        with:
          php-version: 7.4
          coverage: none
          extensions: intl

      - name: Run roave/backward-compatibility-check
        run: ./tools/roave-backward-compatibility-check --from=4.0.2

  tests:
    name: "Tests"

    runs-on: "ubuntu-latest"

    strategy:
      matrix:
        php-version:
          - "7.3"
          - "7.4"
          - "8.0"

        dependencies:
          - "lowest"
          - "highest"

    steps:
      - name: "Checkout"
        uses: "actions/checkout@v2"

      - name: "Install PHP with extensions"
        uses: "shivammathur/setup-php@v1"
        with:
          php-version: "${{ matrix.php-version }}"
          coverage: "pcov"

      - name: "Cache dependencies installed with composer"
        uses: "actions/cache@v1"
        with:
          path: "~/.composer/cache"
          key: "php${{ matrix.php-version }}-composer-${{ matrix.dependencies }}-${{ hashFiles('**/composer.json') }}"
          restore-keys: "php${{ matrix.php-version }}-composer-${{ matrix.dependencies }}-"

      - name: "Set COMPOSER_ROOT_VERSION environment variable"
        uses: "docker://ergebnis/composer-root-version-action:0.1.3"

      - name: "Install lowest dependencies with composer"
        if: "matrix.dependencies == 'lowest'"
        run: "./tools/composer update --no-ansi --no-interaction --no-progress --prefer-lowest"

      - name: "Install highest dependencies with composer"
        if: "matrix.dependencies == 'highest'"
        run: "./tools/composer update --no-ansi --no-interaction --no-progress"

      - name: "Run tests with phpunit/phpunit"
        run: "vendor/bin/phpunit --coverage-clover=coverage.xml"

      - name: "Send code coverage report to Codecov.io"
        env:
          CODECOV_TOKEN: "${{ secrets.CODECOV_TOKEN }}"
        run: "bash <(curl -s https://codecov.io/bash) || true"
